/*
 * Copyright (c) 1996 Barton P. Miller
 * 
 * We provide the Paradyn Parallel Performance Tools (below
 * described as Paradyn") on an AS IS basis, and do not warrant its
 * validity or performance.  We reserve the right to update, modify,
 * or discontinue this software at any time.  We shall have no
 * obligation to supply such updates or modifications or any other
 * form of support to you.
 * 
 * This license is for research uses.  For such uses, there is no
 * charge. We define "research use" to mean you may freely use it
 * inside your organization for whatever purposes you see fit. But you
 * may not re-distribute Paradyn or parts of Paradyn, in any form
 * source or binary (including derivatives), electronic or otherwise,
 * to any other organization or entity without our permission.
 * 
 * (for other uses, please contact us at paradyn@cs.wisc.edu)
 * 
 * All warranties, including without limitation, any warranty of
 * merchantability or fitness for a particular purpose, are hereby
 * excluded.
 * 
 * By your use of Paradyn, you understand and agree that we (or any
 * other person or entity with proprietary rights in Paradyn) are
 * under no obligation to provide either maintenance services,
 * update services, notices of latent defects, or correction of
 * defects for Paradyn.
 * 
 * Even if advised of the possibility of such damages, under no
 * circumstances shall we (or any other person or entity with
 * proprietary rights in the software licensed hereunder) be liable
 * to you or any third party for direct, indirect, or consequential
 * damages of any character regardless of type of action, including,
 * without limitation, loss of profits, loss of use, loss of good
 * will, or computer failure or malfunction.  You agree to indemnify
 * us (and any other person or entity with proprietary rights in the
 * software licensed hereunder) for any and all liability it may
 * incur to third parties resulting from your use of Paradyn.
 */





/************************************************************************
 * kludges.h: the name says it all. stop compiler warnings.
************************************************************************/





#if !defined(_thread_src_kludges_h_)
#define _thread_src_kludges_h_





/************************************************************************
 * header files.
************************************************************************/

#include <stdarg.h>
#include <stdio.h>
#include <sys/types.h>

#if !defined(i386_unknown_nt4_0)
#include <sys/time.h>
#endif /* !defined(i386_unknown_nt4_0) */




/************************************************************************
 * common definitions and declarations.
************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif /* defined(__cplusplus) */

typedef void (*Sa_Handler)(void);

#if defined(__cplusplus)
}
#endif /* defined(__cplusplus) */





/************************************************************************
 * architecture-os definitions and declarations.
************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif /* defined(__cplusplus) */

#if defined(i386_unknown_bsd)

#define FDBITS_OF(x) (&(x))

#endif /* defined(i386_unknown_bsd) */



#if defined(hppa1_1_hp_hpux)

#define FDBITS_OF(x) ((int *) ((x).fds_bits))

#endif /* defined(hppa1_1_hp_hpux) */



#if defined(mips_dec_ultrix4_3)

#define FDBITS_OF(x) (&(x))

extern void bzero(char *, int);
extern int  select(int, fd_set *, fd_set *, fd_set *, struct timeval *);

#endif /* defined(mips_dec_ultrix4_3) */



#if defined(i386_unknown_solaris2_5) || defined(i386_unknown_linux2_0) || defined(ia64_unknown_linux2_4) /* Temporary duplication - TLM */

#define FDBITS_OF(x) (&(x))

#endif /* defined(i386_unknown_solaris2_5) */



#if defined(sparc_sun_solaris2_4)

#define FDBITS_OF(x) (&(x))

#endif /* defined(sparc_sun_solaris2_4) */



#if defined(sparc_sun_sunos4_1_3)

#define FDBITS_OF(x) (&(x))

extern void bzero(char *, int);
extern int  select(int, fd_set *, fd_set *, fd_set *, struct timeval *);

#endif /* defined(sparc_sun_sunos4_1_3) */



#if defined(rs6000_ibm_aix3_2) || defined(rs6000_ibm_aix4_1)

#define FDBITS_OF(x) (&(x))
#include <sys/select.h>

#endif




#if defined(mips_sgi_irix6_4)

#define FDBITS_OF(x) (&(x))

#endif /* defined(mips_sgi_irix6_4) */



#if defined(i386_unknown_nt4_0)

#define	FDBITS_OF(x)	(&(x))

#endif /* defined(i386_unknown_nt4_0) */



#if defined(__cplusplus)
}
#endif /* defined(__cplusplus) */





/************************************************************************
 * for c-compilers without proper include files.
************************************************************************/

#if !defined(__cplusplus)

#if defined(mips_dec_ultrix4_3)
extern int  fflush(FILE *);
extern int  fprintf(FILE *, const char *, ...);
extern int  printf(const char *, ...);
extern int  vsprintf(char *, const char *, va_list);
extern void perror(const char *);
#endif /* defined(mips_dec_ultrix4_3) */

#if defined(sparc_sun_sunos4_1_3)
extern int  fflush(FILE *);
extern int  fprintf(FILE *, const char *, ...);
extern int  printf(const char *, ...);
extern int  vsprintf(char *, const char *, va_list);
extern void perror(const char *);
#endif /* defined(sparc_sun_sunos4_1_3) */

#endif /* !defined(__cplusplus) */





#endif /* !defined(_thread_src_kludges_h_) */
